<template>
  <el-row :gutter="40" class="panel-group">
    <el-col :xs="12" :sm="12" :lg="6" class="card-panel-col">
      <div class="card-panel --blue" @click="handleSetLineChartData('newVisitis')">
        <div class="card-panel-description">
          <div class="card-panel-text">Total petani yang telah</div>
          <div class="card-panel-info --blue">Terdaftar</div>
          <div>
            <count-to
              :start-val="0"
              :end-val="this.registered_id"
              :duration="2600"
              class="card-panel-num"
            />
            <svg-icon icon-class="peoples" class="--blue"/>
          </div>
          <div class="card-panel__bottom">
            <div class="card-panel-icon-wrapper icon-message">
              <svg-icon icon-class="terdaftar" class-name="card-panel-icon" />
            </div>
          </div>
        </div>
      </div>
    </el-col>
    <el-col :xs="12" :sm="12" :lg="6" class="card-panel-col">
      <div class="card-panel --green" @click="handleSetLineChartData('messages')">
        <div class="card-panel-description">
          <div class="card-panel-text">Total semua</div>
          <div class="card-panel-info --green">Lahan</div>
          <div>
            <count-to
              :start-val="0"
              :end-val="this.registered_field"
              :duration="3000"
              class="card-panel-num"
            />
            <svg-icon icon-class="peoples" class="--green"/>
          </div>
          <div class="card-panel__bottom">
            <div class="card-panel-icon-wrapper icon-message">
              <svg-icon icon-class="lahan-green" class-name="card-panel-icon" />
            </div>
          </div>
        </div>
      </div>
    </el-col>
    <el-col :xs="12" :sm="12" :lg="6" class="card-panel-col">
      <div class="card-panel --orange" @click="handleSetLineChartData('purchases')">
        <div class="card-panel-description">
          <div class="card-panel-text">Total semua</div>
          <div class="card-panel-info --orange">Komoditas</div>
          <div>
            <count-to
              :start-val="0"
              :end-val="this.commodity_farmer"
              :duration="3200"
              class="card-panel-num"
            />
            <svg-icon icon-class="peoples" class="--orange"/>
          </div>
          <div class="card-panel__bottom">
            <div class="card-panel-icon-wrapper icon-money">
              <svg-icon icon-class="leaf-orange" class-name="card-panel-icon" />
            </div>
          </div>
        </div>
      </div>
    </el-col>
    <el-col :xs="12" :sm="12" :lg="6" class="card-panel-col">
      <div class="card-panel --red" @click="handleSetLineChartData('shoppings')">
        <div class="card-panel-description">
          <div class="card-panel-text">Petani mencatat</div>
          <div class="card-panel-info --red">Aktivitas</div>
          <div>
            <count-to
              :start-val="0"
              :end-val="this.active_farmer"
              :duration="3600"
              class="card-panel-num"
            />
            <svg-icon icon-class="peoples" class="--red"/>
          </div>
          <div class="card-panel__bottom">
            <div class="card-panel-icon-wrapper icon-shopping">
              <svg-icon icon-class="aktifitas" class-name="card-panel-icon" />
            </div>
          </div>
        </div>
      </div>
    </el-col>
  </el-row>
</template>

<script>
import CountTo from 'vue-count-to';
export default {
  components: {
    CountTo
  },
  computed: {
    active_farmer: {
      get: function() {
        const farmers = this.$store.state.farmer.farmers;
        return farmers.totalActiveFarmer;
      }
    },
    commodity_farmer: {
      get: function() {
        const farmers = this.$store.state.farmer.farmers;
        return farmers.getAllCommodity;
      }
    },
    registered_field: {
      get: function() {
        const farmers = this.$store.state.farmer.farmers;
        return farmers.getAllField;
      }
    },
    registered_id: {
      get: function() {
        const farmers = this.$store.state.farmer.farmers;
        return farmers.totalRegisteredFarmer;
      }
    }
  },
  methods: {
    handleSetLineChartData(type) {
      this.$emit('handleSetLineChartData', type);
    }
  },
  props: {
    farmers: {
      type: Object,
      required: true
    }
  }
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';
.panel-group {
  margin-top: 18px;
  .card-panel-col {
    margin-bottom: 32px;
  }
  .card-panel {
    cursor: pointer;
    font-size: 12px;
    position: relative;
    padding: 13px 20px;
    overflow: hidden;
    color: #4a4a4a;
    height: 165px;
    background: #fff;
    box-shadow: 4px 4px 40px rgba(0, 0, 0, 0.05);
    border-color: rgba(0, 0, 0, 0.05);
    @include ritx-box;
    position: relative;

    &.\-\-blue {
      background: #b9e4ea;
    }
    &.\-\-green {
      background: #cce4bb;
    }
    &.\-\-orange {
      background: #ece3bb;
    }
    &.\-\-red {
      background: #f7d1c7;
    }

    .svg-icon {
      vertical-align: top;

      &.\-\-blue {
        color: #0076a9;
      }
      &.\-\-green {
        color: #5f9e32;
      }
      &.\-\-orange {
        color: #dfa42b;
      }
      &.\-\-red {
        color: #de3636;
      }
    }

    &:hover {
      .card-panel-icon-wrapper {
        color: #fff;
      }
    }
    .icon-people {
      color: #40c9c6;
    }
    .icon-message {
      color: #36a3f7;
    }
    .icon-money {
      color: #f4516c;
    }
    .icon-shopping {
      color: #34bfa3;
    }
    .card-panel-icon-wrapper {
      margin: 14px 0 0 14px;
      transition: all 0.38s ease-out;
      border-radius: 6px;
    }
    .card-panel-icon {
      float: left;
      font-size: 80px;
    }
    .card-panel-description {
      float: left;
      font-weight: bold;
      margin-left: 0px;
      width: 100%;
      .card-panel {
        &-text {
          line-height: 1.4;
          font-size: 14px;
        }
        &-info {
          font-size: 20px;
          margin-bottom: 25px;

          &.\-\-blue {
            color: #0076a9;
          }
          &.\-\-green {
            color: #5f9e32;
          }
          &.\-\-orange {
            color: #dfa42b;
          }
          &.\-\-red {
            color: #de3636;
          }
        }
      }
      .card-panel-num {
        font-size: 56px;
        vertical-align: top;
        line-height: 0.8;
      }
    }
    &--active {
      background: linear-gradient(200deg, $ritx-light-green, $ritx-dark-green);
      color: $true-white;
      .card-panel {
        &-text {
          color: $true-white !important;
        }
      }
    }
    &__bottom {
      position: absolute;
      bottom: -4px;
      right: 0px;
    }
  }
}
</style>
